VERSION 5.00
Object = "{E684D8A3-716C-4E59-AA94-7144C04B0074}#1.1#0"; "gridex20.ocx"
Begin VB.Form frmMIDIKeys 
   Caption         =   "MIDI Keys - By Mr-Yellow"
   ClientHeight    =   5010
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4755
   Icon            =   "MIDIKeys.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5010
   ScaleWidth      =   4755
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboBlockSpace 
      Height          =   315
      ItemData        =   "MIDIKeys.frx":08CA
      Left            =   2640
      List            =   "MIDIKeys.frx":08D4
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   4560
      Width           =   735
   End
   Begin VB.Timer Timer1 
      Left            =   120
      Top             =   4560
   End
   Begin VB.CommandButton cmdEnable 
      Caption         =   "Enable"
      Default         =   -1  'True
      Height          =   375
      Left            =   3600
      TabIndex        =   3
      Top             =   4560
      Width           =   975
   End
   Begin VB.ComboBox cboOutput 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   3495
   End
   Begin GridEX20.GridEX GridEXKeys 
      Height          =   3855
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   4500
      _ExtentX        =   7938
      _ExtentY        =   6800
      Version         =   "2.0"
      AutomaticSort   =   -1  'True
      BoundColumnIndex=   ""
      ReplaceColumnIndex=   ""
      ColumnAutoResize=   -1  'True
      UseEvenOddColor =   -1  'True
      MethodHoldFields=   -1  'True
      Options         =   8
      RecordsetType   =   1
      AllowDelete     =   -1  'True
      GroupByBoxVisible=   0   'False
      RowHeaders      =   -1  'True
      DataMode        =   1
      AllowAddNew     =   -1  'True
      ColumnHeaderHeight=   285
      FrozenColumns   =   1
      ColumnsCount    =   5
      Column(1)       =   "MIDIKeys.frx":08E1
      Column(2)       =   "MIDIKeys.frx":0A55
      Column(3)       =   "MIDIKeys.frx":0B6D
      Column(4)       =   "MIDIKeys.frx":0C85
      Column(5)       =   "MIDIKeys.frx":0D9D
      FormatStylesCount=   6
      FormatStyle(1)  =   "MIDIKeys.frx":0EB5
      FormatStyle(2)  =   "MIDIKeys.frx":0FED
      FormatStyle(3)  =   "MIDIKeys.frx":109D
      FormatStyle(4)  =   "MIDIKeys.frx":1151
      FormatStyle(5)  =   "MIDIKeys.frx":1229
      FormatStyle(6)  =   "MIDIKeys.frx":12E1
      ImageCount      =   0
      PrinterProperties=   "MIDIKeys.frx":13C1
   End
   Begin VB.ComboBox cboChan 
      Height          =   315
      ItemData        =   "MIDIKeys.frx":1599
      Left            =   3720
      List            =   "MIDIKeys.frx":15CD
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Block SpaceBar:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   840
      TabIndex        =   5
      Top             =   4560
      Width           =   1695
   End
End
Attribute VB_Name = "frmMIDIKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Implements KeyboardHook

Dim WithEvents mWire As MIDIOXLib.MoxScript
Attribute mWire.VB_VarHelpID = -1
Dim str As String

Private Sub cmdEnable_Click()
    If m_MyHooked Then
        UnhookKeyboard
        m_MyHooked = False
        cmdEnable.Caption = "Enable"
    Else
        HookKeyboard
        m_MyHooked = True
        cmdEnable.Caption = "Disable"
    End If
End Sub

Private Sub Form_Load()
    g_iCount = 0

    Set Keyboardhandler.KeyboardHook = Me
    m_MyHooked = False

    Set mWire = New MIDIOXLib.MoxScript
    Dim x As Integer
    
    cboChan.Clear
    For x = 1 To 16
        cboChan.AddItem x
    Next
    
    cboOutput.Clear
    cboOutput.AddItem "All"
    str = mWire.GetFirstOpenMidiOutDev
    Do While str <> ""
        cboOutput.AddItem str
        str = mWire.GetNextOpenMidiOutDev
    Loop
 
    sDB = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & App.Path & "\" & "dbMIDIKeys.mdb" & ";" & _
        "Jet OLEDB:Database;"
    Dim sSQL As String
    sSQL = "tblMIDIKeys"
    With GridEXKeys
        .CursorLocation = jgexUseServer
        .DatabaseName = sDB
        .LockType = jgexLockPessimistic
        .RecordsetType = jgexRSADOKeyset
        .Options = adCmdTable
        .RecordSource = sSQL
        '.ClearFields
        .Rebind True
    End With
 
    Timer1.Enabled = False
    Timer1.Interval = 10
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnhookKeyboard
   mWire.FireMidiInput = 0
   mWire.DivertMidiInput = 0
   Set mWire = Nothing
End Sub


Public Function NoteOn(ByVal nNote As Long, ByVal nVeloc As Long)

'    On Error GoTo NoteOn_Err
    
    Dim iPort As Integer
    Dim bStatus As Byte
    Dim nChan As Long
    
    If cboChan.Text <> "" Then
        nChan = cboChan.Text
    Else
        nChan = 1
    End If
    nChan = nChan - 1
    bStatus = &H90 + nChan

    If cboOutput.ListIndex = 0 Then
        iPort = -1
    Else
        iPort = cboOutput.ListIndex
    End If
    mWire.OutputMidiMsg iPort, bStatus, nNote, 127
    
NoteOn_Exit:
    On Error Resume Next
    Exit Function
NoteOn_Err:
    'Err.Raise Err.Number, "txtLinkSearch", Err.Description
    DisplayErr "NoteOn", "frmMIDIKeys", Err.Description
    Resume NoteOn_Exit
End Function

Public Function NoteOff(ByVal nNote As Long)

'    On Error GoTo NoteOff_Err

    Dim iPort As Integer
    Dim bStatus As Byte
    Dim nChan As Long
    
    If cboChan.Text <> "" Then
        nChan = cboChan.Text
    Else
        nChan = 1
    End If
    nChan = nChan - 1
    bStatus = &H90 + nChan
    
    If cboOutput.ListIndex = 0 Then
        iPort = -1
    Else
        iPort = cboOutput.ListIndex
    End If
    mWire.OutputMidiMsg iPort, bStatus, nNote, 0
    
NoteOff_Exit:
    On Error Resume Next
    Exit Function
NoteOff_Err:
    'Err.Raise Err.Number, "txtLinkSearch", Err.Description
    DisplayErr "NoteOff", "frmMIDIKeys", Err.Description
    Resume NoteOff_Exit
End Function

Private Sub Timer1_Timer()
   Timer1.Enabled = False
   NoteOn g_iNote, 127
   NoteOff g_iNote
End Sub




Private Function KeyboardHook_BlockAltEscape() As Boolean
  
End Function

Private Function KeyboardHook_BlockAltTab() As Boolean

End Function

Private Function KeyboardHook_BlockControlEscape() As Boolean
  
End Function

Private Function KeyboardHook_BlockSpace() As Boolean
    If cboBlockSpace.Text = "Yes" Then
        KeyboardHook_BlockSpace = True
    End If
End Function



